Ext.require(['Ext.data.*', 'Ext.grid.*']);
Ext.onReady(function() {
	
    Ext.define('Contact', {
        extend: 'Ext.data.Model',
        fields: ['name', 'email','phone']
    });

    var Contacts = Ext.create('Ext.data.Store', {
        model: 'Contact',										// Model
        data: [
            {name: 'Loiane', email: 'me@loiane.com', phone: '1234-5678'},
            {name: 'Peter', email: 'peter@email.com', phone: '2222-2222'},
            {name: 'Ane', email: 'ane@email.com', phone: '3333-3333'},
            {name: 'Harry', email: 'harry@email', phone: '4444-4444'},
            {name: 'Camile', email: 'camile@email.com', phone: '5555-5555'}
        ]
    });
    
    Ext.create('Ext.grid.Panel', {
        renderTo: 'grid-example',
        frame: true,
        store: Contacts,													// 1 : cl store ( Contacts = model + data))
        width: 350,
        title: 'Contacts',
        selType: 'cellmodel',			// Type de selection : cellule  (par dfaut rowmodel)
        columns: [{															// 2 : cl columns 
            text: 'Name',
            flex: 1,
            dataIndex: 'name'
        },{
            text: 'Email',
            flex: 1,
            dataIndex: 'email',
            editor: {					// 4 : l'attribut editor (objet de type Ext.form.field.Field : text, combo, checkbox...) est indispensable pour rendre ditable la cellule
                xtype:'textfield',
                allowBlank:false
            }
        },{
            text: 'Phone',
            flex: 1,
            dataIndex: 'phone',
            editor: {
                xtype:'textfield',
                allowBlank:false
            }
        }],
        plugins: [															// 3 : Plugins															
            Ext.create('Ext.grid.plugin.CellEditing', {			// Plugin Edition de cellule
            	clicksToEdit: 1									// 1 seul click pour diter la cellule
            })
        ]
    });
});
