Ext.require([
    'Ext.grid.*',
    'Ext.data.*'
]);

Ext.onReady(function() {

    Ext.create('Ext.grid.Panel', {									
        store: Ext.create('Ext.data.ArrayStore', {										// 1 : cl store (fields + data)
            fields: [
                {name: 'book'},								// Pas de typage --> la donnes s'affiche comme elle est en base, sous forme de chaine
                {name: 'topic', type: 'string'},			
                {name: 'version', type: 'string'},
                {name: 'released', type: 'boolean'},       // Typage de la colonne
                {name: 'releasedDate', type: 'date'},
                {name: 'value', type: 'number'}
            ],
            data: [
                ['Ext JS 4: First Look','Ext JS','4',false,null,0],
                ['Learning Ext JS 3.2','Ext JS','3.2',true,'2010/10/01',40.49],
                ['Ext JS 3.0 Cookbook','Ext JS','3',true,'2009/10/01',44.99],
                ['Learning Ext JS','Ext JS','2.x',true,'2008/11/01',35.99],
            ]
        }),
        columns: [ 																		// 2 : cl columns 
            Ext.create('Ext.grid.RowNumberer'), // Numero d'enregistrement        
        {
            text: 'Book',
            flex: 1,
            dataIndex: 'book'
        },{
            text: 'Category',
            xtype:'templatecolumn',  // Type de colonne : Template  
            width: 100,
            tpl: '{topic} {version}'  // Formatage = combinaison de 2 champs
        },{
            text: 'Already Released?',
            xtype: 'booleancolumn',    // Type de colonne : boolean
            width: 100,
            dataIndex: 'released',
            trueText: 'Yes',		    // Conversion
            falseText: 'No'
        },{
            text: 'Released Date',
            xtype:'datecolumn',         // Type de colonne : date
            width: 100,
            dataIndex: 'releasedDate',
            format:'m-Y'				// Formatage de la date
        },{
            text: 'Price',
            xtype:'numbercolumn',        // Type de colonne : nombre/money
            width: 80,
            dataIndex: 'value',
            renderer: Ext.util.Format.usMoney // rendu / affichage
        },{
            xtype:'actioncolumn',        // Type de colonne : action utilisateur (Edition / Suppression)
            width:50,
            items: [{
                icon: 'images/edit.png', 
                tooltip: 'Edit',
                handler: function(grid, rowIndex, colIndex) {     // Gestionnaire d'Action : prparer une fonction avec 3 paramtres (grille totale + index ligne + index colonne). ExtJS remplira pour vous.
                    var rec = grid.getStore().getAt(rowIndex);    // Rcuprer l'enregistrement concern
                    Ext.MessageBox.alert('Edit',rec.get('book')); // Afficher le contenu d'une cellunle en particulier 
                }
            },{
                icon: 'images/delete.gif',
                tooltip: 'Delete',
                handler: function(grid, rowIndex, colIndex) {
                    var rec = grid.getStore().getAt(rowIndex);
                    Ext.MessageBox.alert('Delete',rec.get('book'));
                }                
            }]
        }],
		selModel: Ext.create('Ext.selection.CheckboxModel'),									// 3 : cl selModel 
         width: 550,
        title: 'Ext JS Books',
        renderTo: 'grid-example'
    });
});