Ext.require(['Ext.data.*', 'Ext.grid.*']);
Ext.onReady(function() {
	
    Ext.define('Book', {												// Model
        extend: 'Ext.data.Model',
        fields: ['name', 'topic']
    });

    var Books = Ext.create('Ext.data.Store', {           				// Store
        model: 'Book',			// model associ au Store						
        groupField: 'topic',	// Champ dterminant pour grouping
        data: [{
            name: 'Learning Ext JS',
            topic: 'Ext JS'
        },{
            name: 'Learning Ext JS 3.2',
            topic: 'Ext JS'
        },{
            name: 'Ext JS 3.0 Cookbook',
            topic: 'Ext JS'
        },{
            name: 'Expert PHP 5 Tools',
            topic: 'PHP'
        },{
            name: 'NetBeans IDE 7 Cookbook',
            topic: 'Java'
        },{
            name: 'iReport 3.7',
            topic: 'Java'
        },{
            name: 'Python Multimedia',
            topic: 'Python'
        },{
            name: 'NHibernate 3.0 Cookbook',
            topic: '.NET'
        },{
            name: 'ASP.NET MVC 2 Cookbook',
            topic: '.NET'
        }]
    });
    
    Ext.create('Ext.grid.Panel', {										
        renderTo: 'grid-example',
        frame: true,
        store: Books,													// 1 : cl store ( Books = fields + data))
        width: 350,
        height: 400,
        title: 'Books',
        features: [Ext.create('Ext.grid.feature.Grouping',{				// Feature grouping ( INFO : 7 classes dispo dans Ext.grid.feature : AbstractSummary, Chunking, Feature, Grouping, GroupingSummary, RowBody, et Summary
            groupHeaderTpl: 'topic: {name} ({rows.length} Book{[values.rows.length > 1 ? "s" : ""]})'  // Formatage en tte en fonction du nom colonne et Nb d'enregistrements
        })],
        columns: [{														// 2 : cl columns 
            text: 'Name',
            flex: 1,
            dataIndex: 'name'
        },{
            text: 'Topic',
            flex: 1,
            dataIndex: 'topic'
        }]
    });
});
