Ext.Loader.setConfig({     // Chargement de fichiers JS non prsent dans ExtJS
    enabled: true
});

Ext.Loader.setPath('Ext.ux', '/lib/extjs/examples/ux');    // Rpertoire dont on veut que extjs charge explicitement les fichiers JS - ici Fichir RowExpander qui est un plugin

Ext.require([
    'Ext.grid.*',
    'Ext.data.*',
    'Ext.util.*',
    'Ext.grid.PagingScroller'
]);

Ext.onReady(function(){

    Ext.define('Book', {
        extend: 'Ext.data.Model',
        fields: [
           {name: 'name'},
           {name: 'pages', type: 'int'}
        ]
    });



    var store = Ext.create('Ext.data.Store', {
        id: 'store',
        pageSize: 50,  // Combien d'enregistrement  bufferiser ?
        buffered: true, // permet au grid d'interagir avec le paging scroller par buffering
        purgePageCount: 0, // Combien de 'page' mettre en cache avant de 'purger' - Si 0 , signifie 'ne jamais purger' 
        model: 'Book',
        proxy: {
			type: 'ajax',
			url : 'data/infinite.json',
			reader: {
				type: 'json',
				root: 'books'
			}
		},
		autoLoad:true
    });

    var grid = Ext.create('Ext.grid.Panel', {
        width: 400,
        height: 500,
        title: 'Bufffered Grid - 100k records',
        store: store,											// 1 : store
        verticalScroller: {																		// Atribut 1 
            xtype: 'paginggridscroller',
            activePrefetch: false
        },
        loadMask: true,
        invalidateScrollerOnRefresh: false,														// Atribut 2
        disableSelection: true,																	// Atribut 3
        viewConfig: {
            trackOver: false
        },
        columns:[{												// 2 : colonnes
            text: 'Book Name',
            flex:1 ,
            sortable: true,
            dataIndex: 'name'
        },{
            text: 'Pages',
            width: 125,
            sortable: true,
            dataIndex: 'pages'
        }],
        renderTo: 'grid-example'
    });

    store.guaranteeRange(0, 49);  // Charge le store avec un Nb d'enregistrement passs en paramtre (doit tre infrieur  pageSize). Cette methode permettra de grer scrolling
});


