Ext.require(['Ext.data.*', 'Ext.grid.*']);
Ext.onReady(function() {
	
    Ext.define('Contact', {
        extend: 'Ext.data.Model',
        fields: ['name', 'email','phone']
    });

    var Contacts = Ext.create('Ext.data.Store', {
        model: 'Contact',
        data: [
            {name: 'Loiane', email: 'me@loiane.com', phone: '1234-5678'},
            {name: 'Peter', email: 'peter@email.com', phone: '2222-2222'},
            {name: 'Ane', email: 'ane@email.com', phone: '3333-3333'},
            {name: 'Harry', email: 'harry@email', phone: '4444-4444'},
            {name: 'Camile', email: 'camile@email.com', phone: '5555-5555'}
        ]
    });

	var rowEditor = Ext.create('Ext.grid.plugin.RowEditing', {clicksToEdit: 1});

   var grid = Ext.create('Ext.grid.Panel', {
        renderTo: 'grid-example',
        frame: true,
        store: Contacts,																// 1 : cl store ( Contacts = model + data))
        width: 350,
        title: 'Contacts',
        selType: 'rowmodel',
        columns: [{																		// 2 : cl columns
            text: 'Name',
            flex: 1,
            dataIndex: 'name'
        },{
            text: 'Email',
            flex: 1,
            dataIndex: 'email',
            editor: {								// 4 : l'attribut editor
                xtype:'textfield',
                allowBlank:false
            }
        },{
            text: 'Phone',
            flex: 1,
            dataIndex: 'phone',
            editor: {
                xtype:'textfield',
                allowBlank:false
            }
        }],
        plugins: [																		// 3 : Plugins	
            Ext.create('Ext.grid.plugin.RowEditing', {									// Plugin Edition de ligne
            	clicksToEdit: 1
            })
        ],
		dockedItems: [{
				xtype: 'toolbar',
				 dock: 'bottom',   // ou mettre menu Actions ? par defaut en haut de la grille
        displayInfo: true,
				items: [{
						text: 'Add',
					handler : function() {
								rowEditor.cancelEdit();
								// Crer une instance d'enregistrement via le ModelManager
								var r = Ext.ModelManager.create({
										name: 'New Contact',
										email: 'newcontact@email.com',
										phone: '1111-1111'
										}, 'Contact');
								Contacts.insert(0, r);   
								rowEditor.startEdit(0, 0);
							}
					},{
						text: 'Delete',
					 handler: function() {
									var sm = grid.getSelectionModel();
									rowEditor.cancelEdit();
									Contacts.remove(sm.getSelection());
									if (store.getCount() > 0) {
									sm.select(0);
					}
				}
			}]
		}]
    });
});
